/*
 *  file      : src/configuser.c
 *  project   : b2im
 *  copyright : (C) 2015 by BULIN Claude
 * 
 *  This file is part of b2im project
 * 
 *  b2im is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; version 3.
 * 
 *  b2im is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif
#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_b2im/lib.h"
#endif

#include "global.h"
#include "configuser.h"



typedef struct {
	gchar	**Larrbuf;
} CONF;

CONF	Conf = { NULL };

VAR_CONFIG Config = {
	
	10,		// gint	WinPos_X;
	10,		// gint	WinPos_Y;
	200,	// gint	WinWidth;	753
	200,	// gint	WinHeight;	626
	
	// NOTEBOOK_INIT_PACKAGE
	NULL,	// gchar	*path_user;
	NULL,	// gchar	*pathname_manjaro_tools_iso_profiles;
	NULL,	// gchar	*path_cache_iso;
	NULL,	// gchar	*path_folder_manjaro_profiles;
	
	// NOTEBOOK_DESKTOP
	NULL,	// gchar	*string_choice_desktop;

	// NOTEBOOK_KERNEL	
	32,		// gint		choice_kernel_XX_bits;
	0,		// gint		choice_type_image;
	
	// NOTEBOOK_GFXBOOT
	TRUE,	// gboolean	bool_import_picture;
	18,		// gint		choice_num_language;
	0.0,	// float		mainmenu_normal_fg_list_0;
	0.0,	// float		mainmenu_normal_fg_list_1;
	0.0,	// float		mainmenu_normal_fg_list_2;
	
	1.0,	// float		mainmenu_selected_fg_list_0;
	1.0,	// float		mainmenu_selected_fg_list_1;
	1.0,	// float		mainmenu_selected_fg_list_2;
	
	0.0,	// float		mainmenu_bar_color_list_0;
	0.0,	// float		mainmenu_bar_color_list_1;
	0.0,	// float		mainmenu_bar_color_list_2;
	
	0		// gint		choice_num_image_boot;
};


void configuser_remove( void )
{
	// NOTEBOOK_INIT_PACKAGE
	
	if( NULL != Config.path_user ) {
		g_free( Config.path_user );
		Config.path_user = NULL;
	}
	if( NULL != Config.pathname_manjaro_tools_iso_profiles ) {
		g_free( Config.pathname_manjaro_tools_iso_profiles );
		Config.pathname_manjaro_tools_iso_profiles = NULL;
	}
	if( NULL != Config.path_cache_iso ) {
		g_free( Config.path_cache_iso );
		Config.path_cache_iso = NULL;
	}
	if( NULL != Config.path_folder_manjaro_profiles ) {
		g_free( Config.path_folder_manjaro_profiles );
		Config.path_folder_manjaro_profiles = NULL;
	}
	
	// NOTEBOOK_DESKTOP
	
	if( NULL != Config.string_choice_desktop ) {
		g_free( Config.string_choice_desktop );
		Config.string_choice_desktop = NULL;
	}

}

void configuser_save( void )
{
	gchar	*PathNameConfig = xdg_search_config_xdg();		// $HOME/.config/b2im/b2im.conf
	FILE	*fp;
	gchar	*PathNameData = NULL;
	gchar	*Ptr = NULL;
	gchar	**Larrbuf;
	gint	Cpt;
	

	if( NULL != ( fp = fopen( PathNameConfig, "w" ))) {
		fprintf( fp,   "############################################################################\n" );
		fprintf( fp,   "## Fichier de configuration pour : %s\n", PACKAGE_STRING);
		fprintf( fp,   "##--------------------------------------------------------------------------\n" );
		fprintf( fp,   "## File of configuration to : %s\n", PACKAGE_STRING);
		fprintf( fp,   "############################################################################\n" );
		fprintf( fp, "\n" );
		fprintf( fp, "WIN_POS_X                           = %d\n", Config.WinPos_X );
		fprintf( fp, "WIN_POS_Y                           = %d\n", Config.WinPos_Y );
		fprintf( fp, "WIN_WIDTH                           = %d\n", Config.WinWidth );
		fprintf( fp, "WIN_HEIGHT                          = %d\n", Config.WinHeight );
		
		// NOTEBOOK_INIT_PACKAGE
		fprintf( fp, "PATH_CACHE_ISO                      = %s\n", Config.path_cache_iso ? Config.path_cache_iso : "" );
		fprintf( fp, "PATH_FOLDER_MANJARO_PROFILES        = %s\n", Config.path_folder_manjaro_profiles ? Config.path_folder_manjaro_profiles : "");	
		
		// NOTEBOOK_DESKTOP
		fprintf( fp, "STRING_CHOICE_DESKTOP               = %s\n", Config.string_choice_desktop ? Config.string_choice_desktop : "" );
		
		// NOTEBOOK_KERNEL	
		fprintf( fp, "CHOICE_KERNEL_XX_BITS               = %d\n", Config.choice_kernel_XX_bits );
		fprintf( fp, "CHOICE_TYPE_IMAGE                   = %d\n", Config.choice_type_image );
		
		// NOTEBOOK_GFXBOOT
		fprintf( fp, "BOOL_IMPORT_PICTURE                 = %s\n", Config.bool_import_picture ? "TRUE" : "FALSE" );
		fprintf( fp, "CHOICE_NUM_LANGUAGE                 = %d\n", Config.choice_num_language );
		fprintf( fp, "MENU_NORMAL_FG_LIST_0               = %f\n", Config.mainmenu_normal_fg_list_0 );
		fprintf( fp, "MENU_NORMAL_FG_LIST_1               = %f\n", Config.mainmenu_normal_fg_list_1 );
		fprintf( fp, "MENU_NORMAL_FG_LIST_2               = %f\n", Config.mainmenu_normal_fg_list_2 );
		fprintf( fp, "MENU_SELECTED_FG_LIST_0             = %f\n", Config.mainmenu_selected_fg_list_0 );
		fprintf( fp, "MENU_SELECTED_FG_LIST_1             = %f\n", Config.mainmenu_selected_fg_list_1 );
		fprintf( fp, "MENU_SELECTED_FG_LIST_2             = %f\n", Config.mainmenu_selected_fg_list_2 );
		fprintf( fp, "MENU_BAR_COLOR_LIST_0               = %f\n", Config.mainmenu_bar_color_list_0 );
		fprintf( fp, "MENU_BAR_COLOR_LIST_1               = %f\n", Config.mainmenu_bar_color_list_1 );
		fprintf( fp, "MENU_BAR_COLOR_LIST_2               = %f\n", Config.mainmenu_bar_color_list_2 );	
		fprintf( fp, "CHOICE_NUM_IMAGE_BOOT               = %d\n", Config.choice_num_image_boot );
		
		fprintf( fp, "\n" );
		fclose( fp );
	}
	
	// Sauvegarde de la liste des paquets ajoutés
	Ptr = strrchr( PathNameConfig, '/' );
	*Ptr = '\0';
	
	// textview_add_packages
	PathNameData = g_strdup_printf("%s/b2im_datas_add.txt", PathNameConfig );
	Larrbuf = libutils_get_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_packages")) );
	fp = fopen( PathNameData, "w" );
	for( Cpt = 0; Larrbuf[ Cpt ]; Cpt++ ) {
		if( *Larrbuf[ Cpt ] != '\0' ) {
			fprintf( fp, "%s\n", (gchar *)Larrbuf[ Cpt ] );
		}
	}
	g_strfreev( Larrbuf );
	Larrbuf = NULL;
	fclose( fp );
	g_free( PathNameData );
	PathNameData = NULL;
	
	// textview_add_to_home
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home.txt", PathNameConfig );
	Larrbuf = libutils_get_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home")) );
	fp = fopen( PathNameData, "w" );
	for( Cpt = 0; Larrbuf[ Cpt ]; Cpt++ ) {
		if( *Larrbuf[ Cpt ] != '\0' ) {
			fprintf( fp, "%s\n", (gchar *)Larrbuf[ Cpt ] );
		}
	}
	g_strfreev( Larrbuf );
	Larrbuf = NULL;
	fclose( fp );
	g_free( PathNameData );
	PathNameData = NULL;
	
	// textview_add_to_home_config
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home_config.txt", PathNameConfig );
	Larrbuf = libutils_get_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home_config")) );
	fp = fopen( PathNameData, "w" );
	for( Cpt = 0; Larrbuf[ Cpt ]; Cpt++ ) {
		if( *Larrbuf[ Cpt ] != '\0' ) {
			fprintf( fp, "%s\n", (gchar *)Larrbuf[ Cpt ] );
		}
	}
	g_strfreev( Larrbuf );
	Larrbuf = NULL;
	fclose( fp );
	g_free( PathNameData );
	PathNameData = NULL;
	
	// textview_add_to_home_local_share
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home_local_share.txt", PathNameConfig );
	Larrbuf = libutils_get_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home_local_share")) );
	fp = fopen( PathNameData, "w" );
	for( Cpt = 0; Larrbuf[ Cpt ]; Cpt++ ) {
		if( *Larrbuf[ Cpt ] != '\0' ) {
			fprintf( fp, "%s\n", (gchar *)Larrbuf[ Cpt ] );
		}
	}
	g_strfreev( Larrbuf );
	Larrbuf = NULL;
	fclose( fp );
	g_free( PathNameData );
	PathNameData = NULL;
	
	
	g_free( PathNameConfig );
	PathNameConfig = NULL;
}

void configuser_read_to_textview( void )
{
	size_t 		SizeFile;
	gchar		*Buffer = NULL;
	FILE		*fp = NULL;
	gchar	*PathNameConfig = xdg_search_config_xdg();		// $HOME/.config/b2im/b2im.conf
	gchar	*PathNameData = NULL;
	gchar	*Ptr = NULL;

	// Sauvegarde de la liste des paquets ajoutés
	Ptr = strrchr( PathNameConfig, '/' );
	*Ptr = '\0';
	
	// textview_add_packages
	PathNameData = g_strdup_printf("%s/b2im_datas_add.txt", PathNameConfig );
	if(( SizeFile = libutils_get_size_file( PathNameData )) > 0 ) {
		if( NULL != ( fp = fopen( PathNameData, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			libutils_set_text_to_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_packages")), Buffer );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	g_free( PathNameData );
	PathNameData = NULL;

	// textview_add_to_home
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home.txt", PathNameConfig );
	if(( SizeFile = libutils_get_size_file( PathNameData )) > 0 ) {
		if( NULL != ( fp = fopen( PathNameData, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			libutils_set_text_to_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home")), Buffer );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	g_free( PathNameData );
	PathNameData = NULL;

	// textview_add_to_home_config
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home_config.txt", PathNameConfig );
	if(( SizeFile = libutils_get_size_file( PathNameData )) > 0 ) {
		if( NULL != ( fp = fopen( PathNameData, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			libutils_set_text_to_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home_config")), Buffer );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	g_free( PathNameData );
	PathNameData = NULL;

	// textview_add_to_home_local_share
	PathNameData = g_strdup_printf("%s/b2im_textview_add_to_home_local_share.txt", PathNameConfig );
	if(( SizeFile = libutils_get_size_file( PathNameData )) > 0 ) {
		if( NULL != ( fp = fopen( PathNameData, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			libutils_set_text_to_textview( GTK_WIDGET(GLADE_GET_OBJECT("textview_add_to_home_local_share")), Buffer );
			g_free( Buffer );
			Buffer = NULL;
		}
	}
	g_free( PathNameData );
	PathNameData = NULL;

	g_free( PathNameConfig );
	PathNameConfig = NULL;
}

gboolean config_new_strcmp (gchar *p_src, gchar *p_dest)
{
	gint	len_aiguille = strlen (p_dest);
	gint	len_meule;
	gint	len;
	gchar	*PtrBeginSrc = NULL;
	gchar	*PtrEndSrc = NULL;
	gchar	*PtrSrc = NULL;
	gchar	*PtrDest = p_dest;
	
	for (PtrBeginSrc = p_src; *PtrBeginSrc == ' ' || *PtrBeginSrc == '\t'; PtrBeginSrc ++);
	for (PtrEndSrc = PtrBeginSrc; *PtrEndSrc != ' ' && *PtrEndSrc != '\t'; PtrEndSrc ++);
	len_meule = PtrEndSrc - PtrBeginSrc;
	
	if (len_meule != len_aiguille) return (FALSE);
	
	len = 0;
	for (PtrSrc = PtrBeginSrc; PtrSrc < PtrEndSrc; PtrSrc ++, PtrDest ++) {
		if (*PtrSrc != *PtrDest) return (FALSE);;
		len ++;
	}
	
	return (len_meule == len ? TRUE : FALSE);
}
// 
// 
void config_print_data (gchar *p_str)
{
	gint	len = strlen( p_str );
	g_print( "%s", p_str );
	while( len < 33 ) {
		g_print( " " );
		len ++;
	}
	g_print( "= " );
}
gchar *config_get_target( gchar *p_buf )
{
	gchar	*Str = NULL;
	gchar	*Ptr = NULL;
	
	if( NULL != ( Ptr = strchr( p_buf, '=' ))) {
		Ptr ++;
		while( *Ptr && (*Ptr != ' ' && *Ptr != '\t' )) Ptr ++;
		Ptr ++;
		Str = g_strdup( Ptr );
		if( NULL != ( Ptr = strchr( Str, '\r' ))) *Ptr = '\0';
		if( NULL != ( Ptr = strchr( Str, '\n' ))) *Ptr = '\0';
	}
	return( (gchar *)Str );
}
// 	
// 	
gboolean config_get_bool( gchar *value )
{
	gchar *ptr = value;

	while( *ptr ) {
		*ptr = toupper( *ptr );
		ptr++;
	}
	return ( !strncmp( value, "TRUE", strlen( "TRUE" )) ? TRUE : FALSE );
}
// LECTURE BOOLEAN
// 
gboolean config_read_value_bool( gchar *p_Search, gboolean *p_ValueBool )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ] ))) {
				*p_ValueBool = config_get_bool( Ptr );
				g_free( Ptr );
				Ptr = NULL;
				
				// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
					config_print_data( p_Search );
					g_print( "%s\n", *p_ValueBool ? "TRUE" : "FALSE" );
				// }
				
				*Conf.Larrbuf[ Cpt ] = '\0';
				return( TRUE );	
			}
		}
	}
	return( FALSE );	
}
// LECTURE NUMERIQUE INT
// 
gboolean config_read_value_atoi( gchar *p_Search, gint *p_ValueAtoi, gint p_Min, gint p_Max )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ] ))) {
				*p_ValueAtoi = atoi( Ptr );
				g_free( Ptr );
				Ptr = NULL;
				if( p_Min > -1 && *p_ValueAtoi < p_Min ) *p_ValueAtoi = p_Min;
				if( p_Max > -1 && *p_ValueAtoi > p_Max ) *p_ValueAtoi = p_Max;
				// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
					config_print_data( p_Search );
					g_print( "%d\n", *p_ValueAtoi ? *p_ValueAtoi : 0 );
				// }
				*Conf.Larrbuf[ Cpt ] = '\0';
				return( TRUE );
			}
		}
	}
	return( FALSE );	
}
// 
//
gboolean config_read_value_float( gchar *p_search, float *p_value_float )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ] ))) {
				//*p_value_float = atof( Ptr );
				*p_value_float = strtod( Ptr, NULL );
				g_free( Ptr );
				Ptr = NULL;
				// if( p_Min > -1 && *p_ValueAtoi < p_Min ) *p_ValueAtoi = p_Min;
				// if( p_Max > -1 && *p_ValueAtoi > p_Max ) *p_ValueAtoi = p_Max;
				// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
					config_print_data( p_search );
					g_print( "%f\n", *p_value_float );
				// }
				*Conf.Larrbuf[ Cpt ] = '\0';
				return( TRUE );
			}
		}
	}
	return( FALSE );	
}
gboolean config_read_value_atol( gchar *p_Search, gulong *p_ValueAtoi, gint p_Min, gint p_Max )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ] ))) {
				*p_ValueAtoi = atol( Ptr );
				g_free( Ptr );
				Ptr = NULL;
				if( p_Min > -1 && *p_ValueAtoi < p_Min ) *p_ValueAtoi = p_Min;
				if( p_Max > -1 && *p_ValueAtoi > p_Max ) *p_ValueAtoi = p_Max;
				// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
					config_print_data( p_Search );
					g_print( "%lu / %lu  ;-)\n", *p_ValueAtoi ? *p_ValueAtoi : 0, G_MAXULONG );
				// }
				*Conf.Larrbuf[ Cpt ] = '\0';
				return( TRUE );
			}
		}
	}
	return( FALSE );	
}
gboolean config_read_value_path( gchar *p_Search, gchar **p_ValuePath, gchar *p_default )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ] ))) {
				if( TRUE == g_file_test( Ptr, G_FILE_TEST_IS_DIR )) {
					*p_ValuePath = Ptr;
				} else {
					if( NULL == p_default )	*p_ValuePath = g_strdup( g_getenv( "HOME" ));
					else			*p_ValuePath = g_strdup( p_default );
					g_free( Ptr );
					Ptr = NULL;
				}
			}
			else {
				if( NULL == p_default )	*p_ValuePath = g_strdup( g_getenv( "HOME" ));
				else			*p_ValuePath = g_strdup( p_default );
			}
			// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
				config_print_data( p_Search );
				g_print( "%s\n", *p_ValuePath ? *p_ValuePath : "" );
			// }
			*Conf.Larrbuf[ Cpt ] = '\0';
			return( TRUE );	
		}
	}
	return( FALSE );	
}
// 
// 
gboolean config_read_value_str( gchar *p_Search, gchar **p_ValueStr )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {
			if( NULL != ( Ptr = config_get_target( Conf.Larrbuf[ Cpt ]))) {
				*p_ValueStr = g_strdup( Ptr );
				g_free( Ptr );
				Ptr = NULL;
				// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
					config_print_data( p_Search );
					g_print( "%s\n", *p_ValueStr ? *p_ValueStr : "" );
				// }
				*Conf.Larrbuf[ Cpt ] = '\0';
				return( TRUE );	
			}
		}
	}
	return( FALSE );	
}
// 
// CALL:
// 	config_read_value_tab( "HOURS_MONDAY", Config.HoursMonday, 4 );
// 
gboolean config_read_value_tab( gchar *p_Search, gint p_ValueTab[], gint p_max_tab )
{
	gchar	*Ptr = NULL;
	gint	Cpt;
	
	// IF NOT INIT IN TAB:
	// 	*(p_ValueTab +0) = 0;
	// 	*(p_ValueTab +1) = 0;
	// 	*(p_ValueTab +2) = 0;
	// 	*(p_ValueTab +3) = 0;
	
	for( Cpt = 0; Conf.Larrbuf[ Cpt ]; Cpt++ ) {
		
		// Si commentaire ou ligne vide alors ligne suivante
		if( *Conf.Larrbuf[ Cpt ] == '#' || *Conf.Larrbuf[ Cpt ] == '\0') continue;
		
		if( TRUE == config_new_strcmp( Conf.Larrbuf[ Cpt ], p_Search )) {

			// if( TRUE == OptionsCommandLine.BoolVerboseMode )
				config_print_data( p_Search );

			if( NULL != (Ptr = strchr( Conf.Larrbuf[ Cpt ], '=' ))) {
				
				gchar	**LarrbufLine = NULL;
				gint	Indice;
				
				// POINTEUR SUR LA PREMIERE OCCURANCE
				Ptr ++;
				while( *Ptr == ' ' || *Ptr == '\t' ) Ptr ++;
				
				// *Ptr IS VALID ?
				if( *Ptr != '\0' ) {
					
					// HOURS_MONDAY                  = 435 690 720 975
					// HOURS_SATURDAY                = 0 0 0 0
					LarrbufLine = g_strsplit( Ptr, " ", 0 );
				
					// INDICE: 0 .. p_max_tab
					for( Indice = 0; LarrbufLine[ Indice ] && Indice < p_max_tab; Indice ++ ) {
					
						*(p_ValueTab +Indice) = (gint)atoi( LarrbufLine[ Indice ] );
					
						// if( TRUE == OptionsCommandLine.BoolVerboseMode ) {
							g_print ("%04d (%02d:%02d)  ",
								*(p_ValueTab +Indice),
								*(p_ValueTab +Indice) / 60,
								*(p_ValueTab +Indice) % 60
								);
						// }
					}
				
					g_strfreev( LarrbufLine );
					LarrbufLine = NULL;
				}
			}
			
			// if( TRUE == OptionsCommandLine.BoolVerboseMode )
				g_print( "\n" );
			
			*Conf.Larrbuf[ Cpt ] = '\0';
			return( TRUE );	
		}
	}
	return( FALSE );	
}
void config_verif_path (gchar **p_ValuePath, gchar *p_default)
{
	if( NULL == *p_ValuePath ) {
		if( NULL == p_default )	*p_ValuePath = g_strdup( g_getenv( "HOME" ));
		else			*p_ValuePath = g_strdup( p_default );
	}
}


void config_close_conf_file( void )
{
	if( NULL != Conf.Larrbuf ) {
		g_strfreev( Conf.Larrbuf );
		Conf.Larrbuf = NULL;
	}
}
gboolean config_open_conf_file( gchar *p_PathNameConfig )
{
	size_t 		SizeFile;
	gchar		*Buffer = NULL;
	FILE		*fp = NULL;
	
	config_close_conf_file();
	if(( SizeFile = libutils_get_size_file( p_PathNameConfig )) > 0 ) {
		if( NULL != ( fp = fopen( p_PathNameConfig, "r" ))) {
			Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
			SizeFile = fread( Buffer, SizeFile, 1, fp );
			fclose( fp );
			Conf.Larrbuf = g_strsplit( Buffer, "\n", 0 );
			g_free( Buffer );
			Buffer = NULL;
			return( TRUE );
		}
	}
	return( FALSE );
}

void configuser_read( void )
{
	gchar	*PathNameConfig = xdg_search_config_xdg();		// $HOME/.config/b2im/b2im.conf
	
	Config.path_user = g_strdup( getenv( "HOME") );

	if( FALSE == g_file_test( PathNameConfig, G_FILE_TEST_EXISTS )) {
		
		gchar	*StrDir = g_strdup( PathNameConfig );
		gchar	*Ptr = NULL;
		
		if( NULL != ( Ptr = strrchr( StrDir, '/' ))) {
			Ptr ++;
			*Ptr = '\0';
		}
		g_mkdir_with_parents( StrDir, 0700 );
		g_free( StrDir );
		StrDir = Ptr = NULL;
		configuser_save ();
		configuser_remove();
		Config.path_user = g_strdup( getenv( "HOME") );
	}
	
	if( TRUE == config_open_conf_file( PathNameConfig )) {
		
		// READ ATOL
		// 
		// config_read_value_atol( "USES_OF_XCFA",				&Config.UsesOfXcfa,       		 0,	-1 );
		
		// READ ATOI
		// 
		config_read_value_atoi( "WIN_POS_X",					&Config.WinPos_X,       		 0,	-1 );
		config_read_value_atoi( "WIN_POS_Y",					&Config.WinPos_Y,       		 0,	-1 );
		config_read_value_atoi( "WIN_WIDTH",					&Config.WinWidth,        		-1,	-1 );
		config_read_value_atoi( "WIN_HEIGHT",					&Config.WinHeight,       		-1,	-1 );
		config_read_value_atoi( "CHOICE_KERNEL_XX_BITS",		&Config.choice_kernel_XX_bits,  -1,	-1 );
		config_read_value_atoi( "CHOICE_TYPE_IMAGE", 			&Config.choice_type_image,  	-1,	-1 );
		config_read_value_atoi( "CHOICE_NUM_LANGUAGE", 			&Config.choice_num_language,  	-1,	-1 );
		config_read_value_atoi( "CHOICE_NUM_IMAGE_BOOT",  		&Config.choice_num_image_boot,  -1,	-1 );
		
		// READ FLOAT
		// 
		config_read_value_float( "MENU_NORMAL_FG_LIST_0",		&Config.mainmenu_normal_fg_list_0 );
		config_read_value_float( "MENU_NORMAL_FG_LIST_1", 		&Config.mainmenu_normal_fg_list_1 );
		config_read_value_float( "MENU_NORMAL_FG_LIST_2", 		&Config.mainmenu_normal_fg_list_2 );
		
		config_read_value_float( "MENU_SELECTED_FG_LIST_0", 	&Config.mainmenu_selected_fg_list_0 );
		config_read_value_float( "MENU_SELECTED_FG_LIST_1", 	&Config.mainmenu_selected_fg_list_1 );
		config_read_value_float( "MENU_SELECTED_FG_LIST_2", 	&Config.mainmenu_selected_fg_list_2 );
		
		config_read_value_float( "MENU_BAR_COLOR_LIST_0", 		&Config.mainmenu_bar_color_list_0 );
		config_read_value_float( "MENU_BAR_COLOR_LIST_1", 		&Config.mainmenu_bar_color_list_1 );
		config_read_value_float( "MENU_BAR_COLOR_LIST_2", 		&Config.mainmenu_bar_color_list_2 );
		
		// READ BOOL
		// 
		config_read_value_bool( "BOOL_IMPORT_PICTURE",			&Config.bool_import_picture );
		
		// READ PATH
		// 
		config_read_value_path( "PATH_CACHE_ISO",				&Config.path_cache_iso,	NULL );
		config_read_value_path( "PATH_FOLDER_MANJARO_PROFILES", &Config.path_folder_manjaro_profiles,	NULL );
		
		// READ STRING
		// 
		config_read_value_str( "STRING_CHOICE_DESKTOP",			&Config.string_choice_desktop );
		
		config_close_conf_file();
		
		// VERIFICATIONS
		config_verif_path( &Config.path_folder_manjaro_profiles,	NULL );
		if( NULL == Config.string_choice_desktop )
			Config.string_choice_desktop = g_strdup( "xfce" );
			

		
	}
	if( NULL != PathNameConfig ) {
		g_free( PathNameConfig );
		PathNameConfig = NULL;
	}
}

